=== debian/changelog ===
testsweeper (2024.05.31-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Sat, 21 Sep 2024 14:11:55 +0200
