=== debian/control ===
Source: testsweeper
Section: devel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper (>= 11),
               python3
Standards-Version: 4.5.1
Homepage: https://github.com/icl-utk-edu/testsweepe
Vcs-Browser: https://salsa.debian.org/debichem-team/testsweeper
Vcs-Git: https://salsa.debian.org/debichem-team/testsweeper.git

Package: libtestsweeper1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Testsuite library
 TBD.

Package: libtestsweeper-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libtestsweeper1 (= ${binary:Version})
Description: Testsuite library (development files)
 TBD.
 .
 This package contains the header files.
