=== debian/watch ===
version=3
https://github.com/icl-utk-edu/testsweeper/tags .*/v([\d.]+)\.tar\.(?:bz2|gz)
