## testsweeper 2025.05.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,13 +14,13 @@
 
 project(
     testsweeper
-    VERSION 2024.05.31
+    VERSION 2025.05.28
     LANGUAGES CXX
 )
 
 # See notes in GNUmakefile about using abi-compliance-checker.
 # soversion is major ABI version.
-set( abi_version 1.0.0 )
+set( abi_version 2.0.0 )
 string( REPLACE "." ";" abi_list "${abi_version}" )
 list( GET abi_list 0 soversion )
