=== debian/changelog ===
testsweeper (2025.05.28-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Mon, 29 Dec 2025 19:17:47 +0100
